/*
# Copyright (c) vhffs project and its contributors
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# 1. Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
#2. Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
#3. Neither the name of vhffs nor the names of its contributors 
#   may be used to endorse or promote products derived from this 
#   software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
#"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
#LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
#FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
#COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
#INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
#BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
#LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
*/

-- DO NOT RUN THIS SCRIPT MANUALLY ! Use updatedb.pl instead --

-- These are the sequences needed for post VHFFS-4.0pre1
-- To know if we need to update this, we should try a SELECT COUNT(*) FROM pg_class WHERE relname = 'seq_id_groups'

-- Drop former (unused) sequences...
DROP SEQUENCE seq_id_groups;
DROP SEQUENCE seq_id_users;
DROP SEQUENCE seq_id_mx;
DROP SEQUENCE seq_id_acl;
DROP SEQUENCE seq_id_cvs;
DROP SEQUENCE seq_id_httpd;
DROP SEQUENCE seq_id_ml;
DROP SEQUENCE seq_id_sub;
DROP SEQUENCE seq_id_mailings;
DROP SEQUENCE seq_virtualuid;
DROP SEQUENCE seq_virtualgid;
DROP SEQUENCE seq_id_pgsql;
DROP SEQUENCE seq_id_svn;
DROP SEQUENCE seq_id_svn_users;
DROP SEQUENCE seq_id_user_group;
DROP SEQUENCE seq_id_mysql;
DROP SEQUENCE seq_id_dns;
DROP SEQUENCE seq_id_history;
DROP SEQUENCE seq_id_objects;

-- Create the same sequences as SERIAL would
CREATE SEQUENCE vhffs_object_object_id_seq;
ALTER TABLE vhffs_object ALTER COLUMN object_id SET DEFAULT nextval('vhffs_object_object_id_seq');
CREATE SEQUENCE vhffs_acl_acl_id_seq;
ALTER TABLE vhffs_acl ALTER COLUMN acl_id SET DEFAULT nextval('vhffs_acl_acl_id_seq');
-- vhffs_group_gid_seq already exists
-- vhffs_users_uid_seq already exists
-- vhffs_confirmation_cid_seq already exists
CREATE SEQUENCE vhffs_cvs_cvs_id_seq;
ALTER TABLE vhffs_cvs ALTER COLUMN cvs_id SET DEFAULT nextval('vhffs_cvs_cvs_id_seq');
CREATE SEQUENCE vhffs_dns_dns_id_seq;
ALTER TABLE vhffs_dns_global ALTER COLUMN dns_id SET DEFAULT nextval('vhffs_dns_dns_id_seq');
-- vhffs_dns_rr_id_seq already exists
-- vhffs_dns_soa_id_seq already exists
CREATE SEQUENCE vhffs_httpd_httpd_id_seq;
ALTER TABLE vhffs_httpd ALTER COLUMN httpd_id SET DEFAULT nextval('vhffs_httpd_httpd_id_seq');
-- vhffs_mailings_id_mailing_seq already exists
CREATE SEQUENCE vhffs_mxdomain_mxdomain_id_seq;
ALTER TABLE vhffs_mxdomain ALTER COLUMN mxdomain_id SET DEFAULT nextval('vhffs_mxdomain_mxdomain_id_seq');
CREATE SEQUENCE vhffs_ml_ml_id_seq;
ALTER TABLE vhffs_ml ALTER COLUMN ml_id SET DEFAULT nextval('vhffs_ml_ml_id_seq');
CREATE SEQUENCE vhffs_ml_subscribers_sub_id_seq;
ALTER TABLE vhffs_ml_subscribers ALTER COLUMN sub_id SET DEFAULT nextval('vhffs_ml_subscribers_sub_id_seq');
CREATE SEQUENCE vhffs_mysql_mysql_id_seq;
ALTER TABLE vhffs_mysql ALTER COLUMN mysql_id SET DEFAULT nextval('vhffs_mysql_mysql_id_seq');
CREATE SEQUENCE vhffs_history_history_id_seq;
ALTER TABLE vhffs_history ALTER COLUMN history_id SET DEFAULT nextval('vhffs_history_history_id_seq');
CREATE SEQUENCE vhffs_pgsql_pgsql_id_seq;
ALTER TABLE vhffs_pgsql ALTER COLUMN pgsql_id SET DEFAULT nextval('vhffs_pgsql_pgsql_id_seq');
-- vhffs_svn_svn_id_seq already exists

CREATE TABLE vhffs_repository
(
	repository_id serial,
	name varchar NOT NULL,
	owner_uid int4 NOT NULL,
	owner_gid int4 NOT NULL,
	quota int4 NOT NULL,
	quota_used int4 NOT NULL DEFAULT 0,
	object_id int4 NOT NULL,
	CONSTRAINT vhffs_repository_pkey PRIMARY KEY (repository_id)
) WITH OIDS;

CREATE VIEW vhffs_forum AS
SELECT users.username, users.passwd, user_info.firstname, user_info.lastname, user_info.mail, user_info.date_creation, object.state
FROM vhffs_users users, vhffs_user_info user_info, vhffs_object object
WHERE user_info.uid=users.uid AND object.object_id=users.object_id;
